package com.macaseinou.sample;

public class SingletonSample1 {

    private static int count = 0;
    
    private static SingletonSample1 instance = null;
    
    private static final Object lock = new Object();
    
    // インスタンスの初期化に時間がかかる
    private SingletonSample1() {
        count++;
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {

        }
    }
    
    public static SingletonSample1 getInstance() {
        // staticフィールドの意図しない編集が行われないようにするため
        // synchronizedブロックで処理をシリアル化
        // スレッドが待ち状態になる
        synchronized (lock) {
            if (instance == null) {
                instance = new SingletonSample1(); 
            }
            try {
                Thread.sleep(100);
            } catch (InterruptedException e) {

            }
        }
        return instance;
    }
    
    public int getCount() {
        return count;
    }

}
