package com.macaseinou.sample;

public class SingletonSample3 {

    private static int count = 0;
    
    private static SingletonSample3 instance = null;
    
    // インスタンスの初期化に時間がかかる
    private SingletonSample3() {
        // staticなフィールド変数が意図しない値へ変更される
        count++;
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {

        }
    }

    public static SingletonSample3 getInstance() {
        // インスタンスの初期化が完了する前にリクエストが送られると
        // 複数回コンストラクタが呼び出される
        if (instance == null) {
            instance = new SingletonSample3();
        }
        try {
            Thread.sleep(100);
        } catch (InterruptedException e) {

        }
        return instance;
    }
    
    public int getCount() {
        return count;
    }


}
 